<template lang="pug">
  div.discord.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row( justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          el-row(justify="center" align="middle" type="flex")
            h2 #[i.bx.bx-book] {{logs ? logs.pair.name : ''}} Logs
          div(v-if="user && logs && !loading")
            el-row(justify="center" type="flex")
              el-row(justify="center" align="middle" type="flex")
                el-avatar(:src="getAvatar(user)")
                el-tag(type="primary") {{user.username}}\#{{user.discriminator}}
            el-divider Logs
            p You can find all the logs for this pair here, from newest to oldest.
            el-row(justify="center" align="middle" type="block" v-for="log in logs.logs" :key="log.timestamp")
              el-card
                el-row(justify="left" align="middle" type="flex")
                  el-avatar.user.avatar(:src="log.user ? getAvatar(log.user) : ''" :icon="log.user ? '' : 'el-icon-user-solid'")
                  el-tag(v-if="log.user" type="primary") {{user.username}}\#{{user.discriminator}}
                  el-tag(v-else type="primary") Unknown#0000
                  el-divider(direction="vertical")
                  el-tag(:type="tagType(log.message)" effect="plain") {{log.message.toUpperCase()}}
                  el-divider(direction="vertical")
                  span {{localTime(log.timestamp)}}
          div(v-else-if="loading")
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-spa] Loading...
            el-row(justify="center" type="flex")
              p(v-loading="loading" element-loading-background="rgba(255, 255, 255, 0.75)") {{quote}}
            el-row(justify="center" type="flex")
              p Please wait while we fetch all logs...
          div(v-else)
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-ghost] You aren't supposed to be here, it seems.
            el-divider Please...
            el-row(justify="center" type="flex")
              NuxtLink(to="/") #[el-button(type="primary") #[i.bx.bx-home] Go Home]
          el-divider(v-if="user && logs && !loading")
          el-row(v-if="user && logs && !loading" justify="center" type="flex")
            NuxtLink(to="/dashboard") #[el-button(type="primary") #[i.bx.bxs-dashboard] Dashboard]
</template>

<script lang="ts">
import Vue from 'vue'

import Easter from '@/middleware/easter'

const easter = new Easter()

function getQuote () {
  const quoter = easter.pick()
  let text = quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]
  text = `${quoter.icon} ${text}`
  return text
}

async function getLogs (token: string, id: string) {
  const api = `/api/v1/logs/${id}`
  const resp = await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
  return resp
}

async function getUser (token: string) {
  const api = '/api/v1/user'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

export default Vue.extend({
  data () {
    return {
      logs: null,
      user: null,
      token: window.localStorage.getItem('coco_token'),
      quote: getQuote(),
      loading: true,
      processing: false,
      toDelete: null as any
    }
  },
  async mounted () {
    if (typeof (this.token) === 'string') {
      const user = await getUser(this.token)
      this.user = await user.json()
      const logs = await getLogs(this.token, this.$route.query.id as string)
      this.logs = await logs.json()
      this.loading = false
    }
  },
  methods: {
    getAvatar (user: any): string | null {
      if (user.avatar) {
        const ext = user.avatar.indexOf('a_') === 0 ? 'gif' : 'png'
        return `https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}.${ext}`
      } else if (user.id === '0') {
        return 'https://i.imgur.com/WoQhP7g.png'
      } else {
        return null
      }
    },
    localTime (stamp: number): string {
      const dt = new Date(stamp * 1000)
      return dt.toLocaleString()
    },
    tagType (msg: string): string {
      if (msg === 'created') {
        return 'success'
      } else if (msg === 'edited') {
        return 'warning'
      } else {
        return 'default'
      }
    }
  }
})
</script>

<style lang="scss" scoped>
.float.right {
  float: right;
}
.user.avatar {
  margin-right: 0.5rem;
}
</style>
